#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_PORT 6666
#define BUF_MAX     255
#define PIN         "1234"

/* <zidylli> */
void str_unexplode(char ** explode)
{
 int i = 0;
 while(explode[i]) free(explode[i++]);
 free(explode);
}

char ** str_explode(char * str, char c)
{
 int depth = 0;
 int i = 0, old;
 char ** exploded = NULL;

 exploded = (char **)malloc(sizeof(char *));
 if ((str[0] == '\0') || ((str[0] == c) && (str[1] == '\0')))
 {
  exploded[0] = NULL;
  return exploded;
 }

 if (str[0] == c) i = 1;
 old = i;
 for(;i<strlen(str)+1;i++)
 {
  if ((str[i] == c) || (str[i] == '\0'))
  {
   depth++;
   exploded = realloc(exploded, (depth + 1) * sizeof(char *));
   exploded[depth - 1] = malloc((i - old + 1) * sizeof(char));
   strncpy(exploded[depth - 1], &str[old], (i - old * sizeof(char)));
   old = i + 1;
  }
 }
 exploded[depth] = NULL;
 return exploded;
}
/* </zidylli> */


/* Procedury obslugi polecen */
void enable(char * result)
{
 printf("  -> Wlaczam cos...\n");
 strcpy(result, "OK\n"); 
}

void disable(char * result)
{
 printf("  -> Wylaczam cos...\n");
 strcpy(result, "OK\n"); 
}

void status(char * result)
{
 strcpy(result, "UNKNOWN\n");
}

#define CHECK_FOR_COMMAND(buf, cmd)   (!strncmp(buf, cmd, strlen(cmd)))
#define SEND_TEXT(fd,s)               send(fd, s, strlen(s), 0)

void child(int clientfd)
{
 char buf[BUF_MAX + 1];
 ssize_t len;
 char ** cmd;
 int i;
 int auth_ok = 0;
 
 while(1)
 {
  len = recv(clientfd, buf, BUF_MAX, 0);
  if (len <= 0) break;
  
  cmd = str_explode(buf, '\n');
  if(!cmd) continue;
  i = 0;
  while(cmd[i])
  {
   if (!auth_ok)
   {
    if (CHECK_FOR_COMMAND(cmd[i], PIN))
    {
     SEND_TEXT(clientfd, "OK\n");    
     auth_ok = 1;     
    }
    else
    {
     SEND_TEXT(clientfd, "No access\n");     
    }
    i++;
    break;
   }
   
   if (CHECK_FOR_COMMAND(cmd[i], "quit"))
   {
    SEND_TEXT(clientfd, "Bye!\n");
    return;
   }
   else if (CHECK_FOR_COMMAND(cmd[i], "enable"))
   {    
    enable(buf);    
    SEND_TEXT(clientfd, buf);
   }
   else if (CHECK_FOR_COMMAND(cmd[i], "disable"))
   {    
    disable(buf);
    SEND_TEXT(clientfd, buf);
   }
   else if (CHECK_FOR_COMMAND(cmd[i], "status"))
   {    
    status(buf);
    SEND_TEXT(clientfd, buf);
   }
   
   i++;
  }
  str_unexplode(cmd);
 }
}

int main(int argc, char * argv[])
{
 int serverfd, clientfd, err;
 socklen_t client_len;
 struct sockaddr_in server_addr, client_addr;
 char client_ip[16];
 pid_t pid;
 
 printf(" -> Inicjuje serwer\n");
 
 serverfd = socket(AF_INET, SOCK_STREAM, 0);
 if (serverfd < 0)
 {
  perror("socket()");
  return 1;
 }
 
 memset(&server_addr, 0, sizeof(struct sockaddr_in));
 server_addr.sin_family = AF_INET;
 server_addr.sin_port = htons(SERVER_PORT);
 err = bind(serverfd, (struct sockaddr *)&server_addr, sizeof(struct sockaddr_in));
 if (err < 0)
 {
  perror("bind()");
  return err;
 }
 
 while(1)
 {
  printf(" -> Czekam na polaczenia\n");
  listen(serverfd, BUF_MAX);
  client_len = sizeof(struct sockaddr_in);
  clientfd = accept(serverfd, (struct sockaddr *)&client_addr, &client_len);
  if (clientfd < 0)
  {
   perror("accept()");
   continue;
  }
  
  inet_ntop(AF_INET, &client_addr.sin_addr, client_ip, 16);
  printf(" -> Polaczenie z %s\n", client_ip);
  pid = fork();
  if (pid < 0)
  {
   perror("fork()");
   continue;
  }
  else if (!pid)
  {
   child(clientfd);
   /* TODO: Jak sie rozlaczyc poprawnie? */
   close(clientfd);
   return 0;
  }
  else
     printf(" -> Uruchamiam watek dla klienta (pid=%d)\n", pid);  
  
  /* Spratamy umarle dzieci */
  while(waitpid(-1, NULL, WNOHANG) > 0);
 }
 
 close(serverfd);
 
 return 0;
}
